/*
   Copyright (C) 1998 T. Scott Dattalo

This file is part of gpsim.

gpsim is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

gpsim is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with gpasm; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */


#ifndef __COMMANDS_H__
#define __COMMANDS_H__

enum COMMAND_MODES
{
  NO_COMMAND,
  COMMAND_PENDING,
  COMMAND_ERROR
};

extern COMMAND_MODES command_mode;
class pic_processor;

class Command
{
public:

  static pic_processor *cpu;

  string name;
  string brief_doc;
  string long_doc;

  COMMAND_MODES command_state;

  virtual COMMAND_MODES execute(int argc, char *argv[]) 
    { 
      printf( "internal error (Command class)\n"); 
      return COMMAND_ERROR;
    };

  Command(void)
    {
      name=string("");
      command_state = NO_COMMAND;
    };

};


extern list <Command *> command_list;
typedef list<Command *>::iterator CL_iterator;
extern CL_iterator cl_iterator;

extern unsigned int quit_gpsim;

Command *
find_command (string name);
void stripwhite (char *string);

#define MAX_ARGUMENTS  20
extern int argc;
extern char *argv[MAX_ARGUMENTS];

extern void initialize_commands(pic_processor *c);
extern main_input(void);
extern COMMAND_MODES execute_line (char *line);

#endif  // __COMMANDS_H__
